<template>
  <div v-if="recipeIngredients">
    <v-toolbar color="primary-accent" dark>
      <v-toolbar-title>Ingredients</v-toolbar-title>
    </v-toolbar>
    <v-row dense v-for="(item, index) in recipeIngredients" :key="index">
      <v-col cols="10">
        <v-row>
          <v-col cols="12" md="4">
            <!-- Quantité de l'ingrédient -->
            <v-text-field required outlined v-model="item.Amount" hide-details single-line type="number" label="Montant" class="mx-2" />
          </v-col>
          <!-- Type de l'ingrédient -->
          <v-col cols="12" md="4">
            <v-select required outlined v-if="RecipeIngredientTypes" v-model="item.RecipeIngredientType" hide-details :items="RecipeIngredientTypes" item-text="Label" return-object label="Unité" single-line class="mx-2"></v-select>
          </v-col>
          <!-- Ingredient -->
          <v-col cols="12" md="4">
            <IngredientSelect @on-change="val => onIngredientSelect(val, index)" />
          </v-col>
        </v-row>
      </v-col>
      <v-col cols="2" class="text-center my-auto">
        <v-btn fab small color="error" title="Supprimer l'ingrédient" @click="removeRecipeIngredient(item)">
        <v-icon dark>mdi-delete</v-icon>
        </v-btn>
      </v-col>
    </v-row>
    <v-toolbar flat>
      <v-spacer></v-spacer>
      <IngredientFormModal />
      <v-btn fab small class="ml-3" color="secondary" title="Ajouter un ingrédient" @click="addRecipeIngredient()">
        <v-icon dark>mdi-plus</v-icon>
      </v-btn>
    </v-toolbar>
  </div>
</template>

<script lang="ts">
import VueWithMixins from "../../../assets/VueWithMixins";
import Component from "vue-class-component";
import { Watch } from "vue-property-decorator";
import RecipeIngredientService from "../../../services/RecipeIngredientService";
import Ingredient from "../../../transport/Ingredient";
import RecipeIngredientType from "../../../transport/RecipeIngredientType";
import IngredientFormModal from "./IngredientFormModal.vue";
import IngredientSelect from "./IngredientSelect.vue";
import RecipeIngredient from "../../../transport/RecipeIngredient";

@Component({ components: { IngredientFormModal, IngredientSelect } })
export default class RecipeIngredientsForm extends VueWithMixins {
  private recipeIngredientService: RecipeIngredientService = null;
  private recipeIngredients: RecipeIngredient[] = [];

  private RecipeIngredientTypes: RecipeIngredientType[] = null;

  private amount: number = 0;
  private selectedIngredient: Ingredient = null;
  private selectedType: string = null;

  onIngredientSelect = (value, index) =>
    (this.recipeIngredients[index].Ingredient = value);

  mounted() {
    this.recipeIngredientService = new RecipeIngredientService();
    this.fetchIngredientsTypes();
    this.recipeIngredients.push(new RecipeIngredient());
  }

  @Watch("recipeIngredients", { deep: true })
  onStepsChanged(value) {
    this.$emit("ingredients-update", value);
  }

  private addRecipeIngredient() {
    if (
      !this.recipeIngredients.find(ingredient => {
          return !ingredient.Amount ||
          !ingredient.Ingredient ||
          !ingredient.RecipeIngredientType
        })
    ) {
      this.recipeIngredients.push(new RecipeIngredient());
    }else
      this.Toast.warning("Impossible d'ajouter un ingrédient si le précédent est incomplet.")

  }

  private fetchIngredientsTypes() {
    this.recipeIngredientService.getRecipeIngredientTypes().then(res => {
      this.RecipeIngredientTypes = res;
    });
  }

  private removeRecipeIngredient(ingredient: RecipeIngredient) {
    this.recipeIngredients.splice(
      this.recipeIngredients.indexOf(ingredient),
      1
    );
  }
}
</script>